var trackingObject = new Object();
var totalScore = 0;
var loCurrentDialog;
var scoreCache = new Object()
var lastReportTitle;
var lastReportMessage;
var lastReportUsername;
var responses = [];//with type, response, grade
var lastTrackHasResponse = false;
var certificateWindow;
var lastCertHTMLFile;
var mozLoaded = false;
var mozDOMListenerRegistered;

function resetScores() {
	totalScore = 0;
	scoreCache = new Object();
}

function setCurrentDialog(dialog_p) {
	loCurrentDialog = dialog_p;
}

function getXHR() {
	var req;
	if (window.XMLHttpRequest && YAHOO.env.ua.ie == 0) {
		req = new XMLHttpRequest();
	} else if (window.ActiveXObject) {
		req = new ActiveXObject("Microsoft.XMLHTTP");
	}
	return req;
}

function loadTracking() {
	var req = getXHR();
	if (req != undefined) {
		req.open("GET", "tracking.json", false);
		req.send(null);
		var trackingList = eval(req.responseText);
		var trackLen = trackingList.length;
		for(var i = 0; i<trackLen; i++) {
			var curTrackItem = trackingList[i];
			trackingObject[curTrackItem.idref] = curTrackItem;
		}
	}
	
	var resumeURL = YAHOO.util.History.getQueryStringParameter('resumeURL');
	if(resumeURL && resumeURL != "" && resumeURL != undefined) {
		req.open("GET", resumeURL, false);
		req.send(null);
		var newResumeData = YAHOO.lang.JSON.parse(req.responseText);
		
		if(newResumeData.linkHistory && newResumeData.quizCache && newResumeData.quizResponses) {		
			totalScore = newResumeData.totalScore;
			lastAHAHLinks = newResumeData.linkHistory;
			scoreCache = newResumeData.quizCache;
			responses = newResumeData.quizResponses;
			
			var startLinkObject = (lastAHAHLinks.length > 1) ? lastAHAHLinks[1] : lastAHAHLinks[0];
			
			if(startLinkObject.target == "pglt01" || startLinkObject.target == "pglt02") {
				
				//we need to reload the last pane set url
				ahah(startLinkObject.lastPaneSetURL, "parentPage", undefined, true);
				
				//we need to load the peer page
				if(startLinkObject.peerURL) {
					var peerTarget = (startLinkObject.target == "pglt01") ? "pglt02" : "pglt01";
					ahah(startLinkObject.peerURL, peerTarget, undefined, true);
				}
				
				lastPaneSetURL = startLinkObject.lastPaneSetURL;
				
				ahah(startLinkObject.url, startLinkObject.target, startLinkObject.delay);
			} else {
				ahah(startLinkObject.url, startLinkObject.target, startLinkObject.delay);
			}		
		}
		
	}
}

function track(id_p, parent_id) {
	var trackItem = trackingObject[id_p];
	if(trackItem) {
		//increment if has score
		if(trackItem.data && trackItem.data != "") {
			var curScoreValue = getScoreValue(trackItem.data);
			if(!scoreCache[id_p] && !scoreCache[parent_id]) {
				totalScore += curScoreValue;
				scoreCache[id_p] = true;
				if(parent_id) {
					scoreCache[parent_id] = true;
				}
			}
			
		}
		if(trackItem.url && trackItem.url != "") {
			var trackURL = trackItem.url;
			//add data query vals if present
			var postData = "totalScore=" + totalScore;
			
			if(trackItem.data && trackItem.data != "") {
				postData += "&data=" + trackItem.data;
			}
			if(trackItem.marker && trackItem.marker != undefined) {
				if(trackItem.marker.toLowerCase() != "none") {
					postData += "&marker=" + trackItem.marker;
				}
			}
			
			if(lastTrackHasResponse) {
				lastTrackHasResponse = false;
				var latestResponse = responses[responses.length-1];
				if(latestResponse) {
					postData += "&type=" + latestResponse.type;
					postData += "&response=" + latestResponse.response;
					postData += "&grade=" + latestResponse.grade;
				}
			}
			
			var resumeData = {};
			resumeData.totalScore = totalScore;
			resumeData.linkHistory = lastAHAHLinks;
			resumeData.quizCache = scoreCache;
			resumeData.quizResponses = responses;
			
			//add resume data
			postData +=  "&resumeData=" + YAHOO.lang.JSON.stringify(resumeData);
			
			try {
				var request = YAHOO.util.Connect.asyncRequest('POST', trackURL, null, postData);
			} catch(e) {
				//do nothing
			}
			//
		}
	} else {
		//we still want to score cache these
		scoreCache[id_p] = true;
		if(parent_id) {
			scoreCache[parent_id] = true;
		}
	}
}

function displayCurrentScore(id_p) {
	var intervalId = setInterval(function() { 
								 document.getElementById(id_p).innerHTML = totalScore;
								 clearInterval(intervalId); }, 
								 6);
}

function getScoreValue(data_p) {
	var scoreValue;
	if(data_p.indexOf("&") == -1) {
		scoreValue = parseFloat(data_p);
	} else {
		scoreValue = parseFloat(data_p.split("&")[0]);
	}
	
	if(!isNaN(scoreValue)) {
		return scoreValue;
	} else {
		return 0;
	}
}

function changeSizes(size1_p, size2_p) {
	var pglt01 = document.getElementById("pglt01");
	pglt01.className = "span-" + size1_p + " colborder";
	var pglt02 = document.getElementById("pglt02");
	pglt02.className = "span-" + size2_p + " last";
}

function getInnerText(element_p) {
	if(document.body.innerText) {
		return element_p.innerText;
	} else {
		return element_p.textContent;
	}
}

function checkSA(inputId_p) {
	var textArea = document.getElementById(inputId_p);
	if(textArea) {
		lastTrackHasResponse = true;
		var sataRespObj = {};
		sataRespObj.type = "Short Answer";
		sataRespObj.response = textArea.value;
		sataRespObj.grade = "No Grade";
		responses.push(sataRespObj);
	}
	
}

function checkMCA(answerId_p) {
	var answerDiv = document.getElementById(answerId_p);
	if(answerDiv) {
		lastTrackHasResponse = true;
		var sataRespObj = {};
		sataRespObj.type = "Multiple Choice Answer";
		sataRespObj.response = getInnerText(answerDiv);
		sataRespObj.grade = "No Grade";
		responses.push(sataRespObj);
	}
}

function checkSATA(answerList_p, questionId_p, allRightLink_p, someRightLink_p, noneRightLink_p, 
				   allCorrectNoIncorrectLink_p, allCorrectSomeIncorrectLink_p, someCorrectNoIncorrectLink_p,
				   someCorrectSomeIncorrectLink_p, noCorrectSomeIncorrectLink_p, noCorrectAllIncorrectLink_p,
				   id_p, advanced_p) {
	var answerList = new Array();
	var answerSplit = answerList_p.split(",");
	var answerLen = answerSplit.length;
	var someRight = false;
	var someWrong = false;
	
	var allCorrectPicksSelected = true;
	var allIncorrectPicksSelected = true;
	var someCorrectPicksSelected = false;
	var someIncorrectPicksSelected = false;
	
	lastTrackHasResponse = true;
	
	var sataResponses = "";
	var sataRespObj = {};
	sataRespObj.type = "Select All That Apply";
	var foundFirstChecked = false;
	for(var i = 0; i<answerLen; i++) {
		var curId = answerSplit[i];
		var curCheckbox = document.getElementById(curId);
		var checkParent = curCheckbox.parentNode;
		
		if(curCheckbox.checked) {
			if(foundFirstChecked) {
				sataResponses += "\r"
			}
			foundFirstChecked = true;
			sataResponses += getInnerText(checkParent);
		}
		
		if(curCheckbox.checked && curCheckbox.value == "true" || !curCheckbox.checked && curCheckbox.value == "false") {
			someRight = true;
		} else {
			someWrong = true;
		}
		if(!curCheckbox.checked && curCheckbox.value == "true") {
			allCorrectPicksSelected = false;
		}
		if(!curCheckbox.checked && curCheckbox.value == "false") {
			allIncorrectPicksSelected = false;
		}
		if(curCheckbox.checked && curCheckbox.value == "true") {
			someCorrectPicksSelected = true;
		}
		if(curCheckbox.checked && curCheckbox.value == "false") {
			someIncorrectPicksSelected = true;
		}
	}
	
	
	sataRespObj.response = sataResponses;
	
	if(!advanced_p) {
		//do regular simple mode
		//all right = 0, some right = 1, none right = 2
		if(allRightLink_p) {
			//alert("LINK ACTION: answer list: " + answerList_p + " questionId: " + questionId_p);
			if(someRight && someWrong) {
				//SOME RIGHT
				sataRespObj.grade = "Some Right";
				responses.push(sataRespObj);
				track(id_p + "1", questionId_p);
				var linkSplit = someRightLink_p.split(",");
				triggerLinkSplit(linkSplit);
			} else if(someRight && !someWrong) {
				//ALL RIGHT
				sataRespObj.grade = "All Right";
				responses.push(sataRespObj);
				track(id_p + "0", questionId_p);
				var linkSplit = allRightLink_p.split(",");
				triggerLinkSplit(linkSplit);
			} else if(!someRight && someWrong) {
				//NONE RIGHT
				sataRespObj.grade = "None Right";
				responses.push(sataRespObj);
				track(id_p + "2", questionId_p);
				var linkSplit = noneRightLink_p.split(",");
				triggerLinkSplit(linkSplit);
			}
		} else {
			//alert("FEEDBACK ACTION: answer list: " + answerList_p + " questionId: " + questionId_p); 
			if(someRight && someWrong) {
				//SOME RIGHT
				sataRespObj.grade = "Some Right";
				responses.push(sataRespObj);
				track(id_p + "1", questionId_p);
				setCurrentDialog(YAHOO.csb.container["id02" + questionId_p]);
				YAHOO.csb.container["id02" + questionId_p].show();
			} else if(someRight && !someWrong) {
				//ALL RIGHT
				sataRespObj.grade = "All Right";
				responses.push(sataRespObj);
				track(id_p + "0", questionId_p);
				setCurrentDialog(YAHOO.csb.container["id01" + questionId_p]);
				YAHOO.csb.container["id01" + questionId_p].show();
			} else if(!someRight && someWrong) {
				//NONE RIGHT
				sataRespObj.grade = "None Right";
				responses.push(sataRespObj);
				track(id_p + "2", questionId_p);
				setCurrentDialog(YAHOO.csb.container["id03" + questionId_p]);
				YAHOO.csb.container["id03" + questionId_p].show();
			}
		}
	} else {
		//do advanced mode
		//allCorrectNoIncorrectLink = 0, allCorrectSomeIncorrectLink = 1
		//someCorrectNoIncorrectLink = 2, someCorrectSomeIncorrectLink = 3;
		//noCorrectSomeIncorrectLink = 4, noCorrectAllIncorrectLink = 5
		
		if(allRightLink_p) {
			//link action
			if(allCorrectPicksSelected && !someIncorrectPicksSelected) {
				//allCorrectNoIncorrectLink = 0,
				sataRespObj.grade = "All Correct, No Incorrect";
				responses.push(sataRespObj);
				track(id_p + "0", questionId_p);
				var linkSplit = allCorrectNoIncorrectLink_p.split(",");
				triggerLinkSplit(linkSplit);
			} else if(allCorrectPicksSelected && someIncorrectPicksSelected) {
				//allCorrectSomeIncorrectLink = 1
				sataRespObj.grade = "All Correct, Some Incorrect";
				responses.push(sataRespObj);
				track(id_p + "1", questionId_p);
				var linkSplit = allCorrectSomeIncorrectLink_p.split(",");
				triggerLinkSplit(linkSplit);
			} else if(someCorrectPicksSelected && !allCorrectPicksSelected && !someIncorrectPicksSelected) {
				//someCorrectNoIncorrectLink = 2
				sataRespObj.grade = "Some Correct, No Incorrect";
				responses.push(sataRespObj);
				track(id_p + "2", questionId_p);
				var linkSplit = someCorrectNoIncorrectLink_p.split(",");
				triggerLinkSplit(linkSplit);
			} else if(someCorrectPicksSelected && !allCorrectPicksSelected && someIncorrectPicksSelected) {
				//someCorrectSomeIncorrectLink = 3
				sataRespObj.grade = "Some Correct, Some Incorrect";
				responses.push(sataRespObj);
				track(id_p + "3", questionId_p);
				var linkSplit = someCorrectSomeIncorrectLink_p.split(",");
				triggerLinkSplit(linkSplit);
			} else if(!someCorrectPicksSelected && someIncorrectPicksSelected && !allIncorrectPicksSelected) {
				//noCorrectSomeIncorrectLink = 4
				sataRespObj.grade = "No Correct, Some Incorrect";
				responses.push(sataRespObj);
				track(id_p + "4", questionId_p);
				var linkSplit = noCorrectSomeIncorrectLink_p.split(",");
				triggerLinkSplit(linkSplit);
			} else if(!someCorrectPicksSelected && allIncorrectPicksSelected) {
				//noCorrectAllIncorrectLink = 5
				sataRespObj.grade = "No Correct, All Incorrect";
				responses.push(sataRespObj);
				track(id_p + "5", questionId_p);
				var linkSplit = noCorrectAllIncorrectLink_p.split(",");
				triggerLinkSplit(linkSplit);
			}
		} else {
			//feedback action
			if(allCorrectPicksSelected && !someIncorrectPicksSelected) {
				//allCorrectNoIncorrectLink = 0
				sataRespObj.grade = "All Correct, No Incorrect";
				responses.push(sataRespObj);
				track(id_p + "0", questionId_p);
				setCurrentDialog(YAHOO.csb.container["id01" + questionId_p]);
				YAHOO.csb.container["id01" + questionId_p].show();
			} else if(allCorrectPicksSelected && someIncorrectPicksSelected) {
				//allCorrectSomeIncorrectLink = 1
				sataRespObj.grade = "All Correct, Some Incorrect";
				responses.push(sataRespObj);
				track(id_p + "1", questionId_p);
				setCurrentDialog(YAHOO.csb.container["id02" + questionId_p]);
				YAHOO.csb.container["id02" + questionId_p].show();
			} else if(someCorrectPicksSelected && !allCorrectPicksSelected && !someIncorrectPicksSelected) {
				//someCorrectNoIncorrectLink = 2
				sataRespObj.grade = "Some Correct, No Incorrect";
				responses.push(sataRespObj);
				track(id_p + "2", questionId_p);
				setCurrentDialog(YAHOO.csb.container["id03" + questionId_p]);
				YAHOO.csb.container["id03" + questionId_p].show();
			} else if(someCorrectPicksSelected && !allCorrectPicksSelected && someIncorrectPicksSelected) {
				//someCorrectSomeIncorrectLink = 3
				sataRespObj.grade = "Some Correct, Some Incorrect";
				responses.push(sataRespObj);
				track(id_p + "3", questionId_p);
				setCurrentDialog(YAHOO.csb.container["id04" + questionId_p]);
				YAHOO.csb.container["id04" + questionId_p].show();
			} else if(!someCorrectPicksSelected && someIncorrectPicksSelected && !allIncorrectPicksSelected) {
				//noCorrectSomeIncorrectLink = 4
				sataRespObj.grade = "No Correct, Some Incorrect";
				responses.push(sataRespObj);
				track(id_p + "4", questionId_p);
				setCurrentDialog(YAHOO.csb.container["id05" + questionId_p]);
				YAHOO.csb.container["id05" + questionId_p].show();
			} else if(!someCorrectPicksSelected && allIncorrectPicksSelected) {
				//noCorrectAllIncorrectLink = 5
				sataRespObj.grade = "No Correct, All Incorrect";
				responses.push(sataRespObj);
				track(id_p + "5", questionId_p);
				setCurrentDialog(YAHOO.csb.container["id06" + questionId_p]);
				YAHOO.csb.container["id06" + questionId_p].show();
			}
		}
	}
	
	
	
}

function triggerLinkSplit(linkSplit_p) {
	if(linkSplit_p.length == 2) {
		//og
		ahah("./content/" + linkSplit_p[0] + ".html", linkSplit_p[1]);
	} else {
		//double split
		ahah("./content/" + linkSplit_p[0] + ".html", "pglt01");
		ahah("./content/" + linkSplit_p[2] + ".html", "pglt02");
	}
}

function checkFITB(id_p, feedbackId_p, answerIds_p) {
	var answerList;
	if(answerIds_p.indexOf(",") == -1) {
		answerList = [answerIds_p];
	} else {
		answerList = answerIds_p.split(",");
	}
	
	//get inputs, and process each one
	var answerLen = answerList.length;
	var numCorrect = 0;
	var toTrack = [];
	for(var i = 0; i<answerLen; i++) {
		var curInput = document.getElementById(answerList[i]);
		var inputAlt = curInput.alt;
		var answerOptions;
		if(inputAlt.indexOf(",") == -1) {
			answerOptions = [inputAlt];
		} else {
			answerOptions = inputAlt.split(",");
		}
		var optionLen = answerOptions.length;
		var matchFound = false;
		for(var j = 0; j<optionLen; j++) {
			if(curInput.value.toString().toLowerCase() == answerOptions[j].toString().toLowerCase()) {
				matchFound = true;
				break;
			}
		}
		if(matchFound) {
			toTrack.push(curInput.id);
			//track(curInput.id);
			//correct
			numCorrect++;
			curInput.className = "fitbCorrect";
		} else {
			scoreCache[curInput.id] = true;
			//incorrect
			curInput.className = "fitbIncorrect";
		}
	}
	
	//do fitb response
	var fitbAnswerValue = document.getElementById(id_p);
	var answerNodes = fitbAnswerValue.childNodes;
	var nodeLen = answerNodes.length;
	var fitbResponse = "";
	for(var i = 0; i<nodeLen; i++) {
		var curNode = answerNodes[i];
		if(curNode.value) {
			fitbResponse += "_" + curNode.value + "_" + " (" + curNode.alt + ")"
		} else if(curNode.nodeType == 3) {
			fitbResponse += curNode.nodeValue;
		}
	}
	
	var fitbRespObj = {};
	fitbRespObj.type = "Fill-In-The-Blank";
	fitbRespObj.response = fitbResponse;
	fitbRespObj.grade = numCorrect + " out of " + answerLen;
	responses.push(fitbRespObj);
	
	//don't set lastTrackHasResponse until last track
	var toTrackLen = toTrack.length;
	for(var i = 0; i<toTrackLen; i++) {
		var curTrackValue = toTrack[i];
		if(i == (toTrackLen-1)) {
			lastTrackHasResponse = true;
		}
		track(curTrackValue);
	}
	
	setCurrentDialog(YAHOO.csb.container[feedbackId_p]);
	YAHOO.csb.container[feedbackId_p].show();
}

function redirectForScore(ranges_p) {
	var intervalId = setInterval(function() { 
								 executeRedirectForScore(ranges_p);
								 clearInterval(intervalId); }, 
								 6);
	
}

function executeRedirectForScore(ranges_p) {
	var rangeLen = ranges_p.length;
	for(var i = 0; i<rangeLen; i++) {
		var curRange = ranges_p[i];
		var curTop = parseFloat(curRange.top);
		var curBottom = parseFloat(curRange.bottom);
		if(totalScore >= curBottom && totalScore <= curTop) {
			returnToLastAHAH();
			ahah(curRange.link, curRange.target);
			track(curRange.id);
			break;
		}
	}
}

//certificate functionality
function viewCertificate() {
	var usernameField = document.getElementById("usernameFieldCert");
	if(usernameField.value == "") {
		alert("Enter your name first.");
	} else {
		lastReportUsername = usernameField.value;
		YAHOO.csb.container.viewCertificateDialog.cancel();
		openCertificate(lastCertHTMLFile);
	}
	
}

function initCertificateDialog() {
	YAHOO.namespace("csb.container");
	YAHOO.csb.container.viewCertificateDialog = new YAHOO.widget.Dialog("viewCertificateDialogForm", { 
																		width: "350px",
																		fixedcenter: true,
																		visible: false, 
																		constraintoviewport: true,
																		modal: true
																		} );
	YAHOO.csb.container.viewCertificateDialog.render();
}

//reporting functionality
function reportSent() {
	alert("Report Sent: Success");
}

function proxyReportSentFail(o) {
	alert("Proxy Report Sent: Fail: " + o.statusText);
}

function reportSentFail(o) {
	//let's do the proxy
	var postData = generateReportPOST();
	var request = YAHOO.util.Connect.asyncRequest('POST', "./proxy.php", reportCallback, postData);
}

var proxyReportCallback = {
success:reportSent,
failure:proxyReportSentFail,
argument:[]
};

var reportCallback = {
success:reportSent,
failure:reportSentFail,
argument:[]
};

function pingReportService() {
	var usernameField = document.getElementById("usernameField");
	if(usernameField.value == "") {
		alert("Enter your name first.");
	} else {
		lastReportUsername = usernameField.value;
		//assemble message
		lastReportMessage = "Hello,\r\r";
		lastReportMessage += "This is a report from the CSB Reporting Service.\r\r"
		lastReportMessage += encodeURIComponent(lastReportUsername) + " has finished the '" + encodeURIComponent(lastReportTitle) + "' learning activity.\r";
		lastReportMessage += "Their total score for this session was: " + totalScore + ".\r\r\r";
		lastReportMessage += "Thanks,\rCSB Reporting Service";
		
		YAHOO.csb.container.sendReportDialog.cancel();
		var postData = generateReportPOST();
		try {
			var request = YAHOO.util.Connect.asyncRequest('POST', reportServiceEndpoint, reportCallback, postData);
		} catch(e) {
			reportSentFail(e);
		}
	}
	
}

function generateReportPOST() {
	var certTitle = (lastReportTitle) ? lastReportTitle : document.title;
	var postData = "token=" + reportServiceToken +
					"&subject=CSB Report: " + encodeURIComponent(lastReportTitle) + " from " + encodeURIComponent(lastReportUsername) +
					"&body=" + lastReportMessage + 
					"&title=" + encodeURIComponent(certTitle) + 
					"&userName=" + encodeURIComponent(lastReportUsername) + 
					"&score=" + totalScore;
	
	return postData;
	
}

function initReportDialog() {
	YAHOO.namespace("csb.container");
	YAHOO.csb.container.sendReportDialog = new YAHOO.widget.Dialog("sendReportDialogForm", { 
																   width: "350px",
																   fixedcenter: true,
																   visible: false, 
																   constraintoviewport: true,
																   modal: true
																   } );
	YAHOO.csb.container.sendReportDialog.render();
}

function sendReport(reportTitle_p) {
	lastReportTitle = reportTitle_p;
	lastReportTitle = lastReportTitle.replace('&amp;', '&', "gi");
	lastReportTitle = lastReportTitle.replace("&lt;", "<", "gi");
	lastReportTitle = lastReportTitle.replace("&gt;", ">", "gi");
	lastReportTitle = lastReportTitle.replace("&quot;", '"', "gi");
	lastReportTitle = lastReportTitle.replace("&#39;", "'", "gi");
	
	YAHOO.csb.container.sendReportDialog.show();
}

function openCertificate(file_p) {
	lastCertHTMLFile = file_p;
	if(!lastReportUsername) {
		YAHOO.csb.container.viewCertificateDialog.show();
	} else {
		mozLoaded = false;
		mozDOMListenerRegistered = false;
		certificateWindow = window.open(lastCertHTMLFile);
		window.setTimeout(checkCertificateWindow, 20);
	}
}

function mozContentLoaded() {
	mozLoaded = true;
}

function checkCertificateWindow() {
	if(certificateWindow.document && !mozDOMListenerRegistered) {
		if(certificateWindow.document.addEventListener)  {
			certificateWindow.document.addEventListener("DOMContentLoaded", mozContentLoaded, false);
		}
	}
	if(certificateWindow.document.readyState == "complete" || mozLoaded) {
		window.setTimeout(initCertificateWindow, 20);
	} else {
		window.setTimeout(checkCertificateWindow, 20);
	}
}

function initCertificateWindow() {
	//date
	var curDate = new Date();
	var monthList = ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"];
	var month = monthList[curDate.getMonth()];
	var day = curDate.getDate();
	var year = curDate.getFullYear();
	var dateField = certificateWindow.document.getElementById("date_id");
	if(dateField) {
		dateField.innerHTML = month + " " + day + ", " + year;
	}
	//title
	var titleField = certificateWindow.document.getElementById("title_id");
	var certTitle = (lastReportTitle) ? lastReportTitle : document.title;
	if(titleField) {
		titleField.innerHTML = certTitle;
	}
	certificateWindow.document.title = certTitle;
	//name
	var nameField = certificateWindow.document.getElementById("name_id");
	if(nameField) {
		nameField.innerHTML = lastReportUsername;
	}
	//expiration?
	var expField = certificateWindow.document.getElementById("expiration_id");
	if(expField) {
		expField.innerHTML = month + " " + day + ", " + (year + 1);
	}
}